﻿
Imports System.Threading

Public Module modThreadControl



    '==================================== THREADS   =============================================

    Public Sub subStartThreads()
        Try

            classNewBackground = New classBackground()
            Dim threadBackground As New Thread(AddressOf classNewBackground.subBackgroundMonitor)
            threadBackground.IsBackground = True
            threadBackground.Start()

            Dim API1MainThread As New Thread(AddressOf classAPI1Server.subMain)
            API1MainThread.IsBackground = True
            API1MainThread.Start()

            Dim API2MainThread As New Thread(AddressOf classAPI2Server.subMain)
            API2MainThread.IsBackground = True
            API2MainThread.Start()

            classNewRccClient = New classRccClient()
            Dim RccClientMainThread As New Thread(AddressOf classNewRccClient.subMain)
            RccClientMainThread.IsBackground = True
            RccClientMainThread.Start()

            classNewGotAGlyphClient = New classGotAGlyphClient()
            Dim GotAGlyphClientMainThread As New Thread(AddressOf classNewGotAGlyphClient.subMain)
            GotAGlyphClientMainThread.IsBackground = True
            GotAGlyphClientMainThread.Start()

            evntCourseCorrection = New classCourseCorrection()
            Dim CourseCorrectionThreadObject As New classCourseCorrection()
            Dim CourseCorrectionMainThread As New Thread(AddressOf evntCourseCorrection.subCourseCorrection_Top)
            CourseCorrectionMainThread.IsBackground = True
            CourseCorrectionMainThread.Start()

            classNewObstacleMoving = New classObstacleMoving()
            Dim ObstacleMoving2DscanMainThread As New Thread(AddressOf classNewObstacleMoving.subPreventCollisions)
            ObstacleMoving2DscanMainThread.IsBackground = True
            ObstacleMoving2DscanMainThread.Start()

            classNewAddImageToQueue = New classAddImageToQueue()
            Dim AddImageToQueueMainThread As New Thread(AddressOf classNewAddImageToQueue.subGetMoreRecognizedImages)
            AddImageToQueueMainThread.IsBackground = True
            AddImageToQueueMainThread.Start()

        Catch ex As Exception
            frmDebug.subWriteLogs(" EXCEPTION in subStartThreads :  " & ex.ToString)
        End Try
    End Sub



    '==================================== Background  Thread  =============================================
    Dim WithEvents classNewBackground As classBackground

    '==================================== Local RCC Client Thread  =============================================
    Dim WithEvents classNewRccClient As classRccClient

    '==================================== GotAGlyph Client Thread  =============================================
    Dim WithEvents classNewGotAGlyphClient As classGotAGlyphClient

    '==================================== Course Correction Thread  =============================================
    Dim CourseCorrectionThread As Thread   '?? 
    Delegate Sub DelegateevntCourseCorrection()
    Dim WithEvents evntCourseCorrection As classCourseCorrection

    '====================================  Obstacle Moving Thread  =============================================
    Delegate Sub DelegateevntCollisionPredicted()
    Dim WithEvents classNewObstacleMoving As classObstacleMoving

    Sub subCollisionPredictedTop() Handles classNewObstacleMoving.evntCollisionPredicted
        subCollisionPredicted()
    End Sub

    Sub subCollisionPredicted()
        Try
            If frmGotABotTop.InvokeRequired Then
                Dim newDelegate As New DelegateevntCollisionPredicted(AddressOf subCollisionPredicted)
                frmGotABotTop.Invoke(newDelegate)
            Else
                If tmiMoveInfo.boolBotIsMoving Then
                    boolCollisionPredicted = True
                    tbpBotPose = ftnLocalizeUsingDeadReckoning(tbpBotPose, -0.2, True)
                    If tmiMoveInfo.boolBotIsMoving Then tbpBotPose.OrientationUncertainty += 15
                    ftnBotStop(tbpBotPose, tbpBotPose)
                End If
            End If ' GotABotClass.InvokeRequired
        Catch ex As Exception
            frmDebug.subWriteLogs(" EXCEPTION in subCollisionPredicted :  " & ex.ToString)
        End Try
    End Sub


    '==================================== Add Image to Queue  =============================================
    Dim WithEvents classNewAddImageToQueue As classAddImageToQueue


  
 
End Module
